import { DeployResult, MetadataApiDeployOptions as ApiOptions, SourceDeployResult } from './types';
import { MetadataTransfer, MetadataTransferOptions } from './metadataTransfer';
export interface MetadataApiDeployOptions extends MetadataTransferOptions {
    apiOptions?: ApiOptions;
}
export declare class MetadataApiDeploy extends MetadataTransfer<DeployResult, SourceDeployResult> {
    static readonly DEFAULT_OPTIONS: Partial<MetadataApiDeployOptions>;
    private options;
    private deployId;
    constructor(options: MetadataApiDeployOptions);
    protected pre(): Promise<{
        id: string;
    }>;
    protected checkStatus(id: string): Promise<DeployResult>;
    protected post(result: DeployResult): Promise<SourceDeployResult>;
    protected doCancel(): Promise<boolean>;
    private getDeployMessages;
    /**
     * Fix any issues with the deploy message returned by the api.
     * TODO: remove as fixes are made in the api.
     */
    private sanitizeDeployMessage;
}
